Index: source/scriptinterface/ScriptInterface.cpp
===================================================================
--- source/scriptinterface/ScriptInterface.cpp	(Revision 14578)
+++ source/scriptinterface/ScriptInterface.cpp	(Arbeitskopie)
@@ -1272,52 +1304,63 @@
 			size_t len;
 			const jschar* chars = JS_GetStringCharsAndLength(cxFrom, JSVAL_TO_STRING(val), &len);
 			CLONE_REQUIRE(chars, L"JS_GetStringCharsAndLength");
-			JSString* str = JS_NewUCStringCopyN(cxTo, chars, len);
-			CLONE_REQUIRE(str, L"JS_NewUCStringCopyN");
-			jsval rval = STRING_TO_JSVAL(str);
-			m_Mapping[JSVAL_TO_GCTHING(val)] = rval;
-			m_RooterTo.Push(rval);
-			return rval;
+			{
+			    JSAutoRequest rq(cxTo);
+				JSString* str = JS_NewUCStringCopyN(cxTo, chars, len);
+				CLONE_REQUIRE(str, L"JS_NewUCStringCopyN");
+				jsval rval = STRING_TO_JSVAL(str);
+				m_Mapping[JSVAL_TO_GCTHING(val)] = rval;
+				m_RooterTo.append(rval);
+				return rval;
+			}
 		}
 
-		ENSURE(JSVAL_IS_OBJECT(val));
+		ENSURE(!JSVAL_IS_PRIMITIVE(val));
 
 		JSObject* newObj;
 		if (JS_IsArrayObject(cxFrom, JSVAL_TO_OBJECT(val)))
 		{
-			jsuint length;
+			uint length;
 			CLONE_REQUIRE(JS_GetArrayLength(cxFrom, JSVAL_TO_OBJECT(val), &length), L"JS_GetArrayLength");
-			newObj = JS_NewArrayObject(cxTo, length, NULL);
+			{
+				JSAutoRequest rq(cxTo);
+				newObj = JS_NewArrayObject(cxTo, length, NULL);
+			}	
 			CLONE_REQUIRE(newObj, L"JS_NewArrayObject");
 		}
 		else
 		{
-			newObj = JS_NewObject(cxTo, NULL, NULL, NULL);
+			{
+				JSAutoRequest rq(cxTo);
+				newObj = JS_NewObject(cxTo, NULL, NULL, NULL);
+			}
 			CLONE_REQUIRE(newObj, L"JS_NewObject");
 		}
 
 		m_Mapping[JSVAL_TO_GCTHING(val)] = OBJECT_TO_JSVAL(newObj);
-		m_RooterTo.Push(newObj);
+		m_RooterTo.append(OBJECT_TO_JSVAL(newObj));
 
-		AutoJSIdArray ida (cxFrom, JS_Enumerate(cxFrom, JSVAL_TO_OBJECT(val)));
-		CLONE_REQUIRE(ida.get(), L"JS_Enumerate");
+		JS::AutoIdArray ida (cxFrom, JS_Enumerate(cxFrom, JSVAL_TO_OBJECT(val)));
+		CLONE_REQUIRE(ida, L"JS_Enumerate");
+		
+//		AutoGCRooter idaRooter(scriptInterfaceFrom);
+//		idaRooter.Push(&ida);
 
-		AutoGCRooter idaRooter(scriptInterfaceFrom);
-		idaRooter.Push(ida.get());
-
 		for (size_t i = 0; i < ida.length(); ++i)
 		{
 			jsid id = ida[i];
-			jsval idval, propval;
-			CLONE_REQUIRE(JS_IdToValue(cxFrom, id, &idval), L"JS_IdToValue");
-			CLONE_REQUIRE(JS_GetPropertyById(cxFrom, JSVAL_TO_OBJECT(val), id, &propval), L"JS_GetPropertyById");
-			jsval newPropval = GetOrClone(propval);
+			JS::RootedValue idval(cxTo);
+			JS::RootedValue propval(cxTo);
+			CLONE_REQUIRE(JS_IdToValue(cxFrom, id, idval.address()), L"JS_IdToValue");
+			CLONE_REQUIRE(JS_GetPropertyById(cxFrom, JSVAL_TO_OBJECT(val), id, propval.address()), L"JS_GetPropertyById");
+			JS::RootedValue newPropval(cxTo, GetOrClone(propval));
 
 			if (JSVAL_IS_INT(idval))
 			{
 				// int jsids are portable across runtimes
-				CLONE_REQUIRE(JS_SetPropertyById(cxTo, newObj, id, &newPropval), L"JS_SetPropertyById");
-			}
+				JSAutoRequest rq(cxTo);
+				CLONE_REQUIRE(JS_SetPropertyById(cxTo, newObj, id, newPropval.address()), L"JS_SetPropertyById");
+ 						}
 			else if (JSVAL_IS_STRING(idval))
 			{
 				// string jsids are runtime-specific, so we need to copy the string content
@@ -1326,7 +1369,10 @@
 				size_t len;
 				const jschar* chars = JS_GetStringCharsAndLength(cxFrom, idstr, &len);
 				CLONE_REQUIRE(idstr, L"JS_GetStringCharsAndLength (id)");
-				CLONE_REQUIRE(JS_SetUCProperty(cxTo, newObj, chars, len, &newPropval), L"JS_SetUCProperty");
+				{
+					JSAutoRequest rq(cxTo);
+		                	CLONE_REQUIRE(JS_SetUCProperty(cxTo, newObj, chars, len, newPropval.address()), L"JS_SetUCProperty");
+				}
 			}
 			else
 			{
@@ -1341,8 +1387,8 @@
 	JSContext* cxFrom;
 	JSContext* cxTo;
 	std::map<void*, jsval> m_Mapping;
-	AutoGCRooter m_RooterFrom;
-	AutoGCRooter m_RooterTo;
+	JS::AutoValueVector m_RooterFrom;
+	JS::AutoValueVector m_RooterTo;
 };
 
 jsval ScriptInterface::CloneValueFromOtherContext(ScriptInterface& otherContext, jsval val)
@@ -1354,28 +1400,28 @@
 }
 
 ScriptInterface::StructuredClone::StructuredClone() :
-	m_Context(NULL), m_Data(NULL), m_Size(0)
+	m_Data(NULL), m_Size(0)
 {
 }
 
 ScriptInterface::StructuredClone::~StructuredClone()
 {
 	if (m_Data)
-		JS_free(m_Context, m_Data);
+		JS_ClearStructuredClone(m_Data, m_Size);
 }
 
 shared_ptr<ScriptInterface::StructuredClone> ScriptInterface::WriteStructuredClone(jsval v)
 {
-	uint64* data = NULL;
+	JSAutoRequest rq(m->m_cx);
+	uint64_t* data = NULL;
 	size_t nbytes = 0;
-	if (!JS_WriteStructuredClone(m->m_cx, v, &data, &nbytes, NULL, NULL))
+	if (!JS_WriteStructuredClone(m->m_cx, v, &data, &nbytes, NULL, NULL, JSVAL_VOID))
 	{
 		debug_warn(L"Writing a structured clone with JS_WriteStructuredClone failed!");
 		return shared_ptr<StructuredClone>();
 	}
 
 	shared_ptr<StructuredClone> ret (new StructuredClone);
-	ret->m_Context = m->m_cx;
 	ret->m_Data = data;
 	ret->m_Size = nbytes;
 	return ret;
@@ -1383,6 +1429,7 @@
 
 jsval ScriptInterface::ReadStructuredClone(const shared_ptr<ScriptInterface::StructuredClone>& ptr)
 {
+	JSAutoRequest rq(m->m_cx);
 	jsval ret = JSVAL_VOID;
 	JS_ReadStructuredClone(m->m_cx, ptr->m_Data, ptr->m_Size, JS_STRUCTURED_CLONE_VERSION, &ret, NULL, NULL);
 	return ret;
Index: source/scriptinterface/ScriptConversions.cpp
===================================================================
--- source/scriptinterface/ScriptConversions.cpp	(Revision 14578)
+++ source/scriptinterface/ScriptConversions.cpp	(Arbeitskopie)
@@ -32,6 +32,7 @@
 
 template<> bool ScriptInterface::FromJSVal<bool>(JSContext* cx, jsval v, bool& out)
 {
+    JSAutoRequest rq(cx);
 	JSBool ret;
 	WARN_IF_NOT(JSVAL_IS_BOOLEAN(v), v);
 	if (!JS_ValueToBoolean(cx, v, &ret))
@@ -42,7 +43,8 @@
 
 template<> bool ScriptInterface::FromJSVal<float>(JSContext* cx, jsval v, float& out)
 {
-	jsdouble ret;
+    JSAutoRequest rq(cx);
+	double ret;
 	WARN_IF_NOT(JSVAL_IS_NUMBER(v), v);
 	if (!JS_ValueToNumber(cx, v, &ret))
 		return false;
@@ -52,7 +54,8 @@
 
 template<> bool ScriptInterface::FromJSVal<double>(JSContext* cx, jsval v, double& out)
 {
-	jsdouble ret;
+    JSAutoRequest rq(cx);
+	double ret;
 	WARN_IF_NOT(JSVAL_IS_NUMBER(v), v);
 	if (!JS_ValueToNumber(cx, v, &ret))
 		return false;
@@ -62,9 +65,12 @@
 
 template<> bool ScriptInterface::FromJSVal<i32>(JSContext* cx, jsval v, i32& out)
 {
-	int32 ret;
+    JSAutoRequest rq(cx);
+    // TODO: Change FromJSVal to use JS::RootedValue and remove this temporary workaround here
+    JS::RootedValue v1(cx, v);
+	int32_t ret;
 	WARN_IF_NOT(JSVAL_IS_NUMBER(v), v);
-	if (!JS_ValueToECMAInt32(cx, v, &ret))
+	if (!JS::ToInt32(cx, v1, &ret))
 		return false;
 	out = ret;
 	return true;
@@ -72,7 +78,8 @@
 
 template<> bool ScriptInterface::FromJSVal<u32>(JSContext* cx, jsval v, u32& out)
 {
-	uint32 ret;
+    JSAutoRequest rq(cx);
+	uint32_t ret;
 	WARN_IF_NOT(JSVAL_IS_NUMBER(v), v);
 	if (!JS_ValueToECMAUint32(cx, v, &ret))
 		return false;
@@ -82,7 +89,8 @@
 
 template<> bool ScriptInterface::FromJSVal<u16>(JSContext* cx, jsval v, u16& out)
 {
-	uint16 ret;
+    JSAutoRequest rq(cx);
+	uint16_t ret;
 	WARN_IF_NOT(JSVAL_IS_NUMBER(v), v);
 	if (!JS_ValueToUint16(cx, v, &ret))
 		return false;
@@ -92,7 +100,8 @@
 
 template<> bool ScriptInterface::FromJSVal<u8>(JSContext* cx, jsval v, u8& out)
 {
-	uint16 ret;
+    JSAutoRequest rq(cx);
+	uint16_t ret;
 	WARN_IF_NOT(JSVAL_IS_NUMBER(v), v);
 	if (!JS_ValueToUint16(cx, v, &ret))
 		return false;
@@ -102,18 +111,18 @@
 
 template<> bool ScriptInterface::FromJSVal<long>(JSContext* cx, jsval v, long& out)
 {
-	int32 tmp;
-	JSBool ok = JS_ValueToInt32(cx, v, &tmp);
+	int32_t tmp;
+	bool ok = JS_ValueToInt32(cx, v, &tmp);
 	out = (long)tmp;
-	return ok == JS_TRUE;
+	return ok;
 }
 
 template<> bool ScriptInterface::FromJSVal<unsigned long>(JSContext* cx, jsval v, unsigned long& out)
 {
-	int32 tmp;
-	JSBool ok = JS_ValueToInt32(cx, v, &tmp);
+	int32_t tmp;
+	bool ok = JS_ValueToInt32(cx, v, &tmp);
 	out = (unsigned long)tmp;
-	return ok == JS_TRUE;
+	return ok;
 }
 
 // see comment below (where the same preprocessor condition is used)
@@ -143,13 +152,27 @@
 
 #endif
 
-// NOTE: we can't define a jsval specialisation, because that conflicts with integer types
+template<> jsval ScriptInterface::ToJSVal<JS::Value>(JSContext* UNUSED(cx), const JS::Value& val)
+{
+	return val;
+}
+
 template<> bool ScriptInterface::FromJSVal<CScriptVal>(JSContext* UNUSED(cx), jsval v, CScriptVal& out)
 {
 	out = v;
 	return true;
 }
 
+template<> bool ScriptInterface::FromJSVal<JS::RootedObject>(JSContext* UNUSED(cx), jsval v, JS::RootedObject& out)
+{
+	if (v.isObjectOrNull())
+	{
+		out.set(JSVAL_TO_OBJECT(v));
+		return true;
+	}
+	return false;
+}
+
 template<> bool ScriptInterface::FromJSVal<CScriptValRooted>(JSContext* cx, jsval v, CScriptValRooted& out)
 {
 	out = CScriptValRooted(cx, v);
@@ -158,6 +181,7 @@
 
 template<> bool ScriptInterface::FromJSVal<std::wstring>(JSContext* cx, jsval v, std::wstring& out)
 {
+    JSAutoRequest rq(cx);
 	WARN_IF_NOT(JSVAL_IS_STRING(v) || JSVAL_IS_NUMBER(v), v); // allow implicit number conversions
 	JSString* ret = JS_ValueToString(cx, v);
 	if (!ret)
@@ -181,6 +205,7 @@
 
 template<> bool ScriptInterface::FromJSVal<std::string>(JSContext* cx, jsval v, std::string& out)
 {
+    JSAutoRequest rq(cx);
 	WARN_IF_NOT(JSVAL_IS_STRING(v) || JSVAL_IS_NUMBER(v), v); // allow implicit number conversions
 	JSString* ret = JS_ValueToString(cx, v);
 	if (!ret)
@@ -205,22 +230,27 @@
 
 template<> bool ScriptInterface::FromJSVal<Entity>(JSContext* cx, jsval v, Entity& out)
 {
+    JSAutoRequest rq(cx);
 	JSObject* obj;
 	if (!JS_ValueToObject(cx, v, &obj) || obj == NULL)
 		FAIL("Argument must be an object");
 
-	jsval templateName, id, player, position, rotation;
+	JS::RootedValue templateName(cx);
+	JS::RootedValue id(cx);
+	JS::RootedValue player(cx);
+	JS::RootedValue position(cx);
+	JS::RootedValue rotation(cx);
 
 	// TODO: Report type errors
-	if(!JS_GetProperty(cx, obj, "player", &player) || !FromJSVal(cx, player, out.playerID))
+	if(!JS_GetProperty(cx, obj, "player", player.address()) || !FromJSVal(cx, player, out.playerID))
 		FAIL("Failed to read Entity.player property");
-	if (!JS_GetProperty(cx, obj, "templateName", &templateName) || !FromJSVal(cx, templateName, out.templateName))
+	if (!JS_GetProperty(cx, obj, "templateName", templateName.address()) || !FromJSVal(cx, templateName, out.templateName))
 		FAIL("Failed to read Entity.templateName property");
-	if (!JS_GetProperty(cx, obj, "id", &id) || !FromJSVal(cx, id, out.entityID))
+	if (!JS_GetProperty(cx, obj, "id", id.address()) || !FromJSVal(cx, id, out.entityID))
 		FAIL("Failed to read Entity.id property");
-	if (!JS_GetProperty(cx, obj, "position", &position) || !FromJSVal(cx, position, out.position))
+	if (!JS_GetProperty(cx, obj, "position", position.address()) || !FromJSVal(cx, position, out.position))
 		FAIL("Failed to read Entity.position property");
-	if (!JS_GetProperty(cx, obj, "rotation", &rotation) || !FromJSVal(cx, rotation, out.rotation))
+	if (!JS_GetProperty(cx, obj, "rotation", rotation.address()) || !FromJSVal(cx, rotation, out.rotation))
 		FAIL("Failed to read Entity.rotation property");
 
 	return true;
@@ -234,17 +264,15 @@
 	return val ? JSVAL_TRUE : JSVAL_FALSE;
 }
 
-template<> jsval ScriptInterface::ToJSVal<float>(JSContext* cx, const float& val)
+template<> jsval ScriptInterface::ToJSVal<float>(JSContext* UNUSED(cx), const float& val)
 {
-	jsval rval = JSVAL_VOID;
-	JS_NewNumberValue(cx, val, &rval); // ignore return value
+	jsval rval = JS_NumberValue(val);
 	return rval;
 }
 
-template<> jsval ScriptInterface::ToJSVal<double>(JSContext* cx, const double& val)
+template<> jsval ScriptInterface::ToJSVal<double>(JSContext* UNUSED(cx), const double& val)
 {
-	jsval rval = JSVAL_VOID;
-	JS_NewNumberValue(cx, val, &rval); // ignore return value
+	jsval rval = JS_NumberValue(val);
 	return rval;
 }
 
@@ -264,12 +292,11 @@
 	return INT_TO_JSVAL(val);
 }
 
-template<> jsval ScriptInterface::ToJSVal<u32>(JSContext* cx, const u32& val)
+template<> jsval ScriptInterface::ToJSVal<u32>(JSContext* UNUSED(cx), const u32& val)
 {
 	if (val <= JSVAL_INT_MAX)
 		return INT_TO_JSVAL(val);
-	jsval rval = JSVAL_VOID;
-	JS_NewNumberValue(cx, val, &rval); // ignore return value
+	jsval rval = JS_NumberValue(val);
 	return rval;
 }
 
@@ -315,6 +342,7 @@
 
 template<> jsval ScriptInterface::ToJSVal<std::wstring>(JSContext* cx, const std::wstring& val)
 {
+    JSAutoRequest rq(cx);
 	utf16string utf16(val.begin(), val.end());
 	JSString* str = JS_NewUCStringCopyN(cx, reinterpret_cast<const jschar*> (utf16.c_str()), utf16.length());
 	if (str)
@@ -329,6 +357,7 @@
 
 template<> jsval ScriptInterface::ToJSVal<std::string>(JSContext* cx, const std::string& val)
 {
+    JSAutoRequest rq(cx);
 	JSString* str = JS_NewStringCopyN(cx, val.c_str(), val.length());
 	if (str)
 		return STRING_TO_JSVAL(str);
@@ -342,6 +371,7 @@
 
 template<> jsval ScriptInterface::ToJSVal<const char*>(JSContext* cx, const char* const& val)
 {
+    JSAutoRequest rq(cx);
 	JSString* str = JS_NewStringCopyZ(cx, val);
 	if (str)
 		return STRING_TO_JSVAL(str);
@@ -363,30 +393,32 @@
 
 template<typename T> static jsval ToJSVal_vector(JSContext* cx, const std::vector<T>& val)
 {
-	JSObject* obj = JS_NewArrayObject(cx, (jsint)val.size(), NULL);
+	JSAutoRequest rq(cx);
+	JSObject* obj = JS_NewArrayObject(cx, val.size(), NULL);
 	if (!obj)
 		return JSVAL_VOID;
-	for (size_t i = 0; i < val.size(); ++i)
+	for (uint32_t i = 0; i < val.size(); ++i)
 	{
-		jsval el = ScriptInterface::ToJSVal<T>(cx, val[i]);
-		JS_SetElement(cx, obj, (jsint)i, &el);
+		JS::RootedValue el(cx, ScriptInterface::ToJSVal<T>(cx, val[i]));
+		JS_SetElement(cx, obj, i, el.address());
 	}
 	return OBJECT_TO_JSVAL(obj);
 }
 
 template<typename T> static bool FromJSVal_vector(JSContext* cx, jsval v, std::vector<T>& out)
 {
+	JSAutoRequest rq(cx);
 	JSObject* obj;
-	if (!JS_ValueToObject(cx, v, &obj) || obj == NULL || !(JS_IsArrayObject(cx, obj) || js_IsTypedArray(obj)))
+	if (!JS_ValueToObject(cx, v, &obj) || obj == NULL || !(JS_IsArrayObject(cx, obj) || JS_IsTypedArrayObject(obj)))
 		FAIL("Argument must be an array");
-	jsuint length;
+	uint32_t length;
 	if (!JS_GetArrayLength(cx, obj, &length))
 		FAIL("Failed to get array length");
 	out.reserve(length);
-	for (jsuint i = 0; i < length; ++i)
+	for (uint32_t i = 0; i < length; ++i)
 	{
-		jsval el;
-		if (!JS_GetElement(cx, obj, i, &el))
+		JS::RootedValue el(cx);
+		if (!JS_GetElement(cx, obj, i, el.address()))
 			FAIL("Failed to read array element");
 		T el2;
 		if (!ScriptInterface::FromJSVal<T>(cx, el, el2))
Index: source/scripting/SpiderMonkey.h
===================================================================
--- source/scripting/SpiderMonkey.h	(Arbeitskopie)
+++ source/scripting/SpiderMonkey.h	(Arbeitskopie)
@@ -35,8 +35,6 @@
 
 #include "scriptinterface/ScriptTypes.h"
 
-#include "JSUtil.h"
-
 // Make JS debugging a little easier by automatically naming GC roots
 // Don't simply #define NAME_ALL_GC_ROOTS, because jsapi.h is horridly broken
 #ifndef NDEBUG
Index: source/lib/types.h
===================================================================
--- source/lib/types.h	(Revision 14578)
+++ source/lib/types.h	(Arbeitskopie)
@@ -33,12 +33,15 @@
 
 #define i8 int8_t
 #define i16 int16_t
-#define i32 int32_t
+//#define i32 int32_t
+typedef int32_t i32;
 #define i64 int64_t
 
 #define u8  uint8_t
-#define u16 uint16_t
-#define u32 uint32_t
+//#define u16 uint16_t
+typedef uint16_t u16;
+//#define u32 uint32_t
+typedef uint32_t u32;
 #define u64 uint64_t
 
 #endif // #ifndef INCLUDED_TYPES
Index: source/gui/IGUIObject.cpp
===================================================================
--- source/gui/IGUIObject.cpp	(Revision 14578)
+++ source/gui/IGUIObject.cpp	(Arbeitskopie)
@@ -420,6 +420,7 @@
 		throw PSERROR_GUI_OperationNeedsGUIObject();
 		
 	JSContext* cx = pGUI->GetScriptInterface()->GetContext();
+	JSAutoRequest rq(cx);
 	
 	const int paramCount = 1;
 	const char* paramNames[paramCount] = { "mouse" };
@@ -467,7 +468,8 @@
 		return;
 
 	JSContext* cx = m_pGUI->GetScriptInterface()->GetContext();
-
+	JSAutoRequest rq(cx);
+	
 	// Set up the 'mouse' parameter
 	CScriptVal mouse;
 	m_pGUI->GetScriptInterface()->Eval("({})", mouse);
@@ -478,7 +480,7 @@
 	jsval paramData[] = { mouse.get() };
 
 	jsval result;
-	JSBool ok = JS_CallFunctionValue(cx, GetJSObject(), (*it).second.get(), ARRAY_SIZE(paramData), paramData, &result);
+	bool ok = JS_CallFunctionValue(cx, GetJSObject(), (*it).second.get(), ARRAY_SIZE(paramData), paramData, &result);
 	if (!ok)
 	{
 		// We have no way to propagate the script exception, so just ignore it
@@ -498,7 +500,7 @@
 	jsval arg = Argument.get();
 
 	jsval result;
-	JSBool ok = JS_CallFunctionValue(cx, object, (*it).second.get(), 1, &arg, &result);
+	bool ok = JS_CallFunctionValue(cx, object, (*it).second.get(), 1, &arg, &result);
 	if (!ok)
 	{
 		JS_ReportError(cx, "Errors executing script action \"%s\"", Action.c_str());
@@ -508,6 +510,7 @@
 JSObject* IGUIObject::GetJSObject()
 {
 	JSContext* cx = m_pGUI->GetScriptInterface()->GetContext();
+	JSAutoRequest rq(cx);
 	// Cache the object when somebody first asks for it, because otherwise
 	// we end up doing far too much object allocation. TODO: Would be nice to
 	// not have these objects hang around forever using up memory, though.
@@ -515,7 +518,7 @@
 	{
 		JSObject* obj = JS_NewObject(cx, &JSI_IGUIObject::JSI_class, NULL, NULL);
 		m_JSObject = CScriptValRooted(cx, OBJECT_TO_JSVAL(obj));
-		JS_SetPrivate(cx, JSVAL_TO_OBJECT(m_JSObject.get()), this);
+		JS_SetPrivate(JSVAL_TO_OBJECT(m_JSObject.get()), this);
 	}
 	return JSVAL_TO_OBJECT(m_JSObject.get());;
 }
Index: source/gui/scripting/JSInterface_GUITypes.cpp
===================================================================
--- source/gui/scripting/JSInterface_GUITypes.cpp	(Revision 14578)
+++ source/gui/scripting/JSInterface_GUITypes.cpp	(Arbeitskopie)
@@ -23,10 +23,10 @@
 /**** GUISize ****/
 JSClass JSI_GUISize::JSI_class = {
 	"GUISize", 0,
-		JS_PropertyStub, JS_PropertyStub,
+		JS_PropertyStub, JS_DeletePropertyStub,
 		JS_PropertyStub, JS_StrictPropertyStub,
 		JS_EnumerateStub, JS_ResolveStub,
-		JS_ConvertStub, JS_FinalizeStub,
+		JS_ConvertStub, NULL,
 		NULL, NULL, NULL, JSI_GUISize::construct
 };
 
@@ -45,48 +45,61 @@
 
 JSFunctionSpec JSI_GUISize::JSI_methods[] = 
 {
-	{ "toString", JSI_GUISize::toString, 0, 0 },
-	{ 0 }
+	JS_FS("toString", JSI_GUISize::toString, 0, 0),
+	JS_FS_END
 };
 
-JSBool JSI_GUISize::construct(JSContext* cx, uintN argc, jsval* vp)
+JSBool JSI_GUISize::construct(JSContext* cx, uint argc, jsval* vp)
 {
 	JSObject* obj = JS_NewObject(cx, &JSI_GUISize::JSI_class, NULL, NULL);
 
+	// TODO: ugly with so much repetition...?
 	if (argc == 8)
 	{
-		JS_SetProperty(cx, obj, "left",		&JS_ARGV(cx, vp)[0]);
-		JS_SetProperty(cx, obj, "top",		&JS_ARGV(cx, vp)[1]);
-		JS_SetProperty(cx, obj, "right",	&JS_ARGV(cx, vp)[2]);
-		JS_SetProperty(cx, obj, "bottom",	&JS_ARGV(cx, vp)[3]);
-		JS_SetProperty(cx, obj, "rleft",	&JS_ARGV(cx, vp)[4]);
-		JS_SetProperty(cx, obj, "rtop",		&JS_ARGV(cx, vp)[5]);
-		JS_SetProperty(cx, obj, "rright",	&JS_ARGV(cx, vp)[6]);
-		JS_SetProperty(cx, obj, "rbottom",	&JS_ARGV(cx, vp)[7]);
+		JS::RootedValue v0(cx, JS_ARGV(cx, vp)[0]);
+		JS::RootedValue v1(cx, JS_ARGV(cx, vp)[1]);
+		JS::RootedValue v2(cx, JS_ARGV(cx, vp)[2]);
+		JS::RootedValue v3(cx, JS_ARGV(cx, vp)[3]);
+		JS::RootedValue v4(cx, JS_ARGV(cx, vp)[4]);
+		JS::RootedValue v5(cx, JS_ARGV(cx, vp)[5]);
+		JS::RootedValue v6(cx, JS_ARGV(cx, vp)[6]);
+		JS::RootedValue v7(cx, JS_ARGV(cx, vp)[7]);
+		JS_SetProperty(cx, obj, "left",		v0.address());
+		JS_SetProperty(cx, obj, "top",		v1.address());
+		JS_SetProperty(cx, obj, "right",	v2.address());
+		JS_SetProperty(cx, obj, "bottom",	v3.address());
+		JS_SetProperty(cx, obj, "rleft",	v4.address());
+		JS_SetProperty(cx, obj, "rtop",		v5.address());
+		JS_SetProperty(cx, obj, "rright",	v6.address());
+		JS_SetProperty(cx, obj, "rbottom",	v7.address());
 	}
 	else if (argc == 4)
 	{
-		jsval zero = JSVAL_ZERO;
-		JS_SetProperty(cx, obj, "left",		&JS_ARGV(cx, vp)[0]);
-		JS_SetProperty(cx, obj, "top",		&JS_ARGV(cx, vp)[1]);
-		JS_SetProperty(cx, obj, "right",	&JS_ARGV(cx, vp)[2]);
-		JS_SetProperty(cx, obj, "bottom",	&JS_ARGV(cx, vp)[3]);
-		JS_SetProperty(cx, obj, "rleft",	&zero);
-		JS_SetProperty(cx, obj, "rtop",		&zero);
-		JS_SetProperty(cx, obj, "rright",	&zero);
-		JS_SetProperty(cx, obj, "rbottom",	&zero);
+		JS::RootedValue zero(cx, JSVAL_ZERO);
+		JS::RootedValue v0(cx, JS_ARGV(cx, vp)[0]);
+		JS::RootedValue v1(cx, JS_ARGV(cx, vp)[1]);
+		JS::RootedValue v2(cx, JS_ARGV(cx, vp)[2]);
+		JS::RootedValue v3(cx, JS_ARGV(cx, vp)[3]);
+		JS_SetProperty(cx, obj, "left",		v0.address());
+		JS_SetProperty(cx, obj, "top",		v1.address());
+		JS_SetProperty(cx, obj, "right",	v2.address());
+		JS_SetProperty(cx, obj, "bottom",	v3.address());
+		JS_SetProperty(cx, obj, "rleft",	zero.address());
+		JS_SetProperty(cx, obj, "rtop",		zero.address());
+		JS_SetProperty(cx, obj, "rright",	zero.address());
+		JS_SetProperty(cx, obj, "rbottom",	zero.address());
 	}
 	else
 	{
-		jsval zero = JSVAL_ZERO;
-		JS_SetProperty(cx, obj, "left",		&zero);
-		JS_SetProperty(cx, obj, "top",		&zero);
-		JS_SetProperty(cx, obj, "right",	&zero);
-		JS_SetProperty(cx, obj, "bottom",	&zero);
-		JS_SetProperty(cx, obj, "rleft",	&zero);
-		JS_SetProperty(cx, obj, "rtop",		&zero);
-		JS_SetProperty(cx, obj, "rright",	&zero);
-		JS_SetProperty(cx, obj, "rbottom",	&zero);
+		JS::RootedValue zero(cx, JSVAL_ZERO);
+		JS_SetProperty(cx, obj, "left",		zero.address());
+		JS_SetProperty(cx, obj, "top",		zero.address());
+		JS_SetProperty(cx, obj, "right",	zero.address());
+		JS_SetProperty(cx, obj, "bottom",	zero.address());
+		JS_SetProperty(cx, obj, "rleft",	zero.address());
+		JS_SetProperty(cx, obj, "rtop",		zero.address());
+		JS_SetProperty(cx, obj, "rright",	zero.address());
+		JS_SetProperty(cx, obj, "rbottom",	zero.address());
 	}
 
 	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(obj));
@@ -102,7 +115,7 @@
 		return CStr::FromDouble(per)+"%"+( pix == 0.0 ? CStr() : pix > 0.0 ? CStr("+")+CStr::FromDouble(pix) : CStr::FromDouble(pix) );
 }
 
-JSBool JSI_GUISize::toString(JSContext* cx, uintN argc, jsval* vp)
+JSBool JSI_GUISize::toString(JSContext* cx, uint argc, jsval* vp)
 {
 	UNUSED2(argc);
 
@@ -141,10 +154,10 @@
 
 JSClass JSI_GUIColor::JSI_class = {
 	"GUIColor", 0,
-		JS_PropertyStub, JS_PropertyStub,
+		JS_PropertyStub, JS_DeletePropertyStub,
 		JS_PropertyStub, JS_StrictPropertyStub,
 		JS_EnumerateStub, JS_ResolveStub,
-		JS_ConvertStub, JS_FinalizeStub,
+		JS_ConvertStub, NULL,
 		NULL, NULL, NULL, JSI_GUIColor::construct
 };
 
@@ -159,11 +172,11 @@
 
 JSFunctionSpec JSI_GUIColor::JSI_methods[] = 
 {
-	{ "toString", JSI_GUIColor::toString, 0, 0 },
-	{ 0 }
+	JS_FS("toString", JSI_GUIColor::toString, 0, 0),
+	JS_FS_END
 };
 
-JSBool JSI_GUIColor::construct(JSContext* cx, uintN argc, jsval* vp)
+JSBool JSI_GUIColor::construct(JSContext* cx, uint argc, jsval* vp)
 {
 	JSObject* obj = JS_NewObject(cx, &JSI_GUIColor::JSI_class, NULL, NULL);
 
@@ -177,22 +190,23 @@
 	else
 	{
 		// Nice magenta:
-		jsval c;
-		if (!JS_NewNumberValue(cx, 1.0, &c))
+		JS::RootedValue c(cx, JS_NumberValue(1.0));
+		if (JSVAL_IS_NULL(c))
 			return JS_FALSE;
-		JS_SetProperty(cx, obj, "r", &c);
-		JS_SetProperty(cx, obj, "b", &c);
-		JS_SetProperty(cx, obj, "a", &c);
-		if (!JS_NewNumberValue(cx, 0.0, &c))
+		JS_SetProperty(cx, obj, "r", c.address());
+		JS_SetProperty(cx, obj, "b", c.address());
+		JS_SetProperty(cx, obj, "a", c.address());
+		c = JS_NumberValue(0.0);
+		if (JSVAL_IS_NULL(c))
 			return JS_FALSE;
-		JS_SetProperty(cx, obj, "g", &c);
+		JS_SetProperty(cx, obj, "g", c.address());
 	}
 
 	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(obj));
 	return JS_TRUE;
 }
 
-JSBool JSI_GUIColor::toString(JSContext* cx, uintN argc, jsval* vp)
+JSBool JSI_GUIColor::toString(JSContext* cx, uint argc, jsval* vp)
 {
 	UNUSED2(argc);
 
@@ -218,10 +232,10 @@
 
 JSClass JSI_GUIMouse::JSI_class = {
 	"GUIMouse", 0,
-		JS_PropertyStub, JS_PropertyStub,
+		JS_PropertyStub, JS_DeletePropertyStub,
 		JS_PropertyStub, JS_StrictPropertyStub,
 		JS_EnumerateStub, JS_ResolveStub,
-		JS_ConvertStub, JS_FinalizeStub,
+		JS_ConvertStub, NULL,
 		NULL, NULL, NULL, JSI_GUIMouse::construct
 };
 
@@ -235,37 +249,40 @@
 
 JSFunctionSpec JSI_GUIMouse::JSI_methods[] = 
 {
-	{ "toString", JSI_GUIMouse::toString, 0, 0 },
-	{ 0 }
+	JS_FS("toString", JSI_GUIMouse::toString, 0, 0),
+	JS_FS_END
 };
 
-JSBool JSI_GUIMouse::construct(JSContext* cx, uintN argc, jsval* vp)
+JSBool JSI_GUIMouse::construct(JSContext* cx, uint argc, jsval* vp)
 {
 	JSObject* obj = JS_NewObject(cx, &JSI_GUIMouse::JSI_class, NULL, NULL);
 
 	if (argc == 3)
 	{
-		JS_SetProperty(cx, obj, "x", &JS_ARGV(cx, vp)[0]);
-		JS_SetProperty(cx, obj, "y", &JS_ARGV(cx, vp)[1]);
-		JS_SetProperty(cx, obj, "buttons", &JS_ARGV(cx, vp)[2]);
+		JS::RootedValue v0(cx, JS_ARGV(cx, vp)[0]);
+		JS::RootedValue v1(cx, JS_ARGV(cx, vp)[1]);
+		JS::RootedValue v2(cx, JS_ARGV(cx, vp)[2]);
+		JS_SetProperty(cx, obj, "x", v0.address());
+		JS_SetProperty(cx, obj, "y", v1.address());
+		JS_SetProperty(cx, obj, "buttons", v2.address());
 	}
 	else
 	{
-		jsval zero = JSVAL_ZERO;
-		JS_SetProperty(cx, obj, "x", &zero);
-		JS_SetProperty(cx, obj, "y", &zero);
-		JS_SetProperty(cx, obj, "buttons", &zero);
+		JS::RootedValue zero (cx, JSVAL_ZERO);
+		JS_SetProperty(cx, obj, "x", zero.address());
+		JS_SetProperty(cx, obj, "y", zero.address());
+		JS_SetProperty(cx, obj, "buttons", zero.address());
 	}
 
 	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(obj));
 	return JS_TRUE;
 }
 
-JSBool JSI_GUIMouse::toString(JSContext* cx, uintN argc, jsval* vp)
+JSBool JSI_GUIMouse::toString(JSContext* cx, uint argc, jsval* vp)
 {
 	UNUSED2(argc);
 
-	int32 x, y, buttons;
+	int32_t x, y, buttons;
 	ScriptInterface* pScriptInterface = ScriptInterface::GetScriptInterfaceAndCBData(cx)->pScriptInterface;
 	pScriptInterface->GetProperty(JS_THIS_VALUE(cx, vp), "x", x);
 	pScriptInterface->GetProperty(JS_THIS_VALUE(cx, vp), "y", y);
Index: source/gui/scripting/JSInterface_GUITypes.h
===================================================================
--- source/gui/scripting/JSInterface_GUITypes.h	(Revision 14578)
+++ source/gui/scripting/JSInterface_GUITypes.h	(Arbeitskopie)
@@ -26,8 +26,8 @@
 		extern JSClass JSI_class;				\
 		extern JSPropertySpec JSI_props[];		\
 		extern JSFunctionSpec JSI_methods[];	\
-		JSBool construct(JSContext* cx, uintN argc, jsval* vp);	\
-		JSBool toString(JSContext* cx, uintN argc, jsval* vp);	\
+		JSBool construct(JSContext* cx, uint argc, jsval* vp);	\
+		JSBool toString(JSContext* cx, uint argc, jsval* vp);	\
 	}
 
 GUISTDTYPE(Size)
Index: source/gui/scripting/ScriptFunctions.cpp
===================================================================
--- source/gui/scripting/ScriptFunctions.cpp	(Revision 14578)
+++ source/gui/scripting/ScriptFunctions.cpp	(Arbeitskopie)
@@ -69,7 +69,6 @@
 #include "soundmanager/SoundManager.h"
 #include "soundmanager/scripting/JSInterface_Sound.h"
 
-#include "js/jsapi.h"
 /*
  * This file defines a set of functions that are available to GUI scripts, to allow
  * interaction with the rest of the engine.
@@ -552,7 +551,7 @@
 void ForceGC(ScriptInterface::CxPrivate* pCxPrivate)
 {
 	double time = timer_Time();
-	JS_GC(pCxPrivate->pScriptInterface->GetContext());
+	JS_GC(pCxPrivate->pScriptInterface->GetJSRuntime());
 	time = timer_Time() - time;
 	g_Console->InsertMessage(L"Garbage collection completed in: %f", time);
 }
